(function()
{
 var Global=this,Runtime=this.IntelliFactory.Runtime,UI,Next,Var,List,AttrProxy,Doc,Concurrency,Remoting,AjaxRemotingProvider,Var1,View,Operators,Collections,FSharpMap,Seq,MapModule,PrintfHelpers,AttrModule,L,GameLog,JS,Number,Enumerator,T,Math,Arrays,SturmovikServerControl,Client,Strings;
 Runtime.Define(Global,{
  GameLog:{
   JS:{
    newPos3d:function(x,y,z)
    {
     return{
      X:x,
      Y:y,
      Z:z
     };
    },
    op_DotDivide:function(u,k)
    {
     return{
      X:u.X/k,
      Y:u.Y/k,
      Z:u.Z/k
     };
    },
    op_DotMultiply:function(k,u)
    {
     return{
      X:k*u.X,
      Y:k*u.Y,
      Z:k*u.Z
     };
    },
    op_DotPlus:function(u,v)
    {
     return{
      X:u.X+v.X,
      Y:u.Y+v.Y,
      Z:u.Z+v.Z
     };
    },
    strCoalition:function(coalition)
    {
     return coalition.$==1?"Allies":coalition.$==2?"All":"Axis";
    },
    strObjectiveType:function(objective)
    {
     var _,level;
     if(objective.$==1)
      {
       level=objective.$0;
       _="secondary objective "+Global.String(level);
      }
     else
      {
       _="primary objective";
      }
     return _;
    }
   }
  },
  SturmovikServerControl:{
   Client:{
    Login:function()
    {
     var vPassword,vStatus,attrs,submit,x,arg001,statusView,arg20,ats;
     vPassword=Var.Create("");
     vStatus=Var.Create({
      $:0
     });
     attrs=List.ofArray([AttrProxy.Create("type","submit"),AttrProxy.Create("class","btn btn-primary")]);
     submit=Doc.Button("Log in",attrs,function()
     {
      var arg00;
      arg00=Concurrency.Delay(function()
      {
       return Concurrency.Bind(AjaxRemotingProvider.Async("SturmovikServerControl:13",[Var.Get(vPassword)]),function(_arg1)
       {
        Var1.Set(vStatus,_arg1?{
         $:1,
         $0:"OK"
        }:{
         $:1,
         $0:"Failed"
        });
        return Concurrency.Return(null);
       });
      });
      return Concurrency.Start(arg00,{
       $:0
      });
     });
     x=vStatus.get_View();
     arg001=function(msg)
     {
      var _,_1,msg1;
      if(msg.$==1)
       {
        if(msg.$0==="OK")
         {
          _1=Doc.Element("div",List.ofArray([AttrProxy.Create("class","alert alert-success"),AttrProxy.Create("role","alert")]),List.ofArray([Doc.TextNode("OK")]));
         }
        else
         {
          msg1=msg.$0;
          _1=Doc.Element("div",List.ofArray([AttrProxy.Create("class","alert alert-danger"),AttrProxy.Create("role","alert")]),List.ofArray([Doc.TextNode(msg1)]));
         }
        _=_1;
       }
      else
       {
        _=Doc.get_Empty();
       }
      return _;
     };
     statusView=View.Map(arg001,x);
     ats=List.ofArray([AttrProxy.Create("class","form-inline")]);
     arg20=List.ofArray([Doc.Element("form",ats,List.ofArray([Doc.Element("label",List.ofArray([AttrProxy.Create("for","idPassword"),AttrProxy.Create("class","form-control-label")]),List.ofArray([Doc.TextNode("Password")])),Doc.Input(List.ofArray([AttrProxy.Create("type","password"),AttrProxy.Create("class","form-control"),AttrProxy.Create("id","idPassword"),AttrProxy.Create("placeholder","Password")]),vPassword),submit])),Doc.EmbedView(statusView)]);
     return Doc.Element("div",[],arg20);
    },
    RenderMissionEventsMap:function(missionFile,missionMap,log)
    {
     var uiMap,bounds,tileSize,transform,folder,state,idMap,getDescr,arg20,ats,arg201,arg202,arg203,arg204,arg205;
     uiMap=missionMap.indexOf("lapino")!=-1?"lapino":missionMap.indexOf("moscow")!=-1?"moscow":missionMap.indexOf("stalingrad")!=-1?"stalingrad":missionMap;
     bounds=uiMap==="moscow"?[281000,281000]:uiMap==="stalingrad"?[230400,358400]:uiMap==="novosokolniki"?[52200,52200]:uiMap==="lapino"?[52200,52200]:uiMap==="vluki"?[102400,166400]:[1,1];
     tileSize=uiMap==="moscow"?192:uiMap==="stalingrad"?256:256;
     transform=function(tupledArg)
     {
      var latitude,longitude,m;
      latitude=tupledArg[0];
      longitude=tupledArg[1];
      m=Operators.Max(bounds[0],bounds[1]);
      return[tileSize*latitude/m,tileSize*longitude/m];
     };
     folder=function(m)
     {
      return function(entry)
      {
       var matchValue;
       matchValue=entry.Data;
       return matchValue.$==1?m.Add(matchValue.$0,[matchValue.$1,matchValue.$2,matchValue.$3]):matchValue.$==0?m.Add(matchValue.$0,[matchValue.$1,matchValue.$5,matchValue.$4]):m;
      };
     };
     state=FSharpMap.New1([]);
     idMap=Seq.fold(folder,state,log);
     getDescr=function(subject)
     {
      var matchValue,_;
      matchValue=MapModule.TryFind(subject,idMap);
      if(matchValue.$==0)
       {
        return"???";
       }
      else
       {
        _=matchValue.$0[0];
        return PrintfHelpers.toSafe(matchValue.$0[2])+" ("+PrintfHelpers.toSafe(_)+")";
       }
     };
     ats=List.ofArray([AttrProxy.Create("class","table")]);
     arg203=List.ofArray([Doc.TextNode("Time")]);
     arg204=List.ofArray([Doc.TextNode("Event")]);
     arg202=List.ofArray([Doc.Element("th",[],arg203),Doc.Element("th",[],arg204)]);
     arg201=List.ofArray([Doc.Element("tr",[],arg202)]);
     arg205=Seq.toList(Seq.delay(function()
     {
      return Seq.collect(function(event)
      {
       var matchValue,description,typ,completed,_,_1,_2,_3,victim,matchValue1,_4,_5,_6,desc,arg206,arg207,_7,_8,_9,arg208;
       matchValue=event.Data;
       if(matchValue.$==1)
        {
         description={
          $:0
         };
        }
       else
        {
         if(matchValue.$==3)
          {
           typ=matchValue.$3;
           completed=matchValue.$4;
           _=JS.strCoalition(matchValue.$2);
           _1=completed?"completed":"failed";
           _2=JS.strObjectiveType(typ);
           description={
            $:1,
            $0:PrintfHelpers.toSafe(_)+" "+PrintfHelpers.toSafe(_1)+" "+PrintfHelpers.toSafe(_2)
           };
          }
         else
          {
           if(matchValue.$==0)
            {
             _3=matchValue.$1;
             description={
              $:1,
              $0:"Player "+PrintfHelpers.toSafe(matchValue.$4)+" in "+PrintfHelpers.toSafe(_3)
             };
            }
           else
            {
             victim=matchValue.$1;
             matchValue1=MapModule.TryFind(matchValue.$0,idMap);
             if(matchValue1.$==0)
              {
               description={
                $:0
               };
              }
             else
              {
               _4=matchValue1.$0[2];
               _5=matchValue1.$0[0];
               _6=getDescr(victim);
               description={
                $:1,
                $0:PrintfHelpers.toSafe(_4)+" ("+PrintfHelpers.toSafe(_5)+") killed "+PrintfHelpers.toSafe(_6)
               };
              }
            }
          }
        }
       if(description.$==0)
        {
         return Seq.empty();
        }
       else
        {
         desc=description.$0;
         _7=Math.floor(event.Timestamp/3600000)%24;
         _8=Math.floor(event.Timestamp/60000)%60;
         _9=Math.floor(event.Timestamp/1000)%60;
         arg207=List.ofArray([Doc.TextNode("+"+PrintfHelpers.padNumLeft(Global.String(_7),2)+":"+PrintfHelpers.padNumLeft(Global.String(_8),2)+"'"+PrintfHelpers.padNumLeft(Global.String(_9),2)+"\"")]);
         arg208=List.ofArray([Doc.TextNode(desc)]);
         arg206=List.ofArray([Doc.Element("td",[],arg207),Doc.Element("td",[],arg208)]);
         return[Doc.Element("tr",[],arg206)];
        }
      },log);
     }));
     arg20=List.ofArray([Doc.Element("div",List.ofArray([AttrModule.OnAfterRender(function(div)
     {
      var crs,map,x,centerOn,patternInput,y,x1,skullIcon,enumerator,event1,matchValue1,victim,pos,attacker,patternInput1,longi,lat,_,_1,label;
      crs=L.CRS.Simple;
      map=new L.Map(div,{
       crs:crs
      });
      map.addLayer(new L.TileLayer("http://tiles.il2missionplanner.com/"+PrintfHelpers.toSafe(uiMap)+"/{z}/{x}/{y}.png",{
       tms:true,
       maxNativeZoom:6,
       maxZoom:9,
       continuousWorld:true
      }));
      x=Seq.tryPick(function(event)
      {
       var matchValue;
       matchValue=event.Data;
       return matchValue.$==2?{
        $:1,
        $0:matchValue.$2
       }:{
        $:0
       };
      },log);
      centerOn=x.$==0?JS.newPos3d(0,0,0):x.$0;
      patternInput=transform([centerOn.X,centerOn.Z]);
      y=patternInput[1];
      x1=patternInput[0];
      map.setView([Number(x1),Number(y)],4);
      skullIcon=new L.Icon({
       iconUrl:"/Content/WebSharper/SturmovikServerControl/EventIcons2.png",
       iconSize:new L.Point(32,32),
       iconAnchor:new L.Point(16,16),
       shadowAnchor:new L.Point(16,16),
       popupAnchor:new L.Point(0,42)
      });
      enumerator=Enumerator.Get(log);
      try
      {
       while(enumerator.MoveNext())
        {
         event1=enumerator.get_Current();
         matchValue1=event1.Data;
         if(matchValue1.$==2)
          {
           victim=matchValue1.$1;
           pos=matchValue1.$2;
           attacker=matchValue1.$0;
           patternInput1=transform([pos.X,pos.Z]);
           longi=patternInput1[1];
           lat=patternInput1[0];
           _=getDescr(attacker);
           _1=getDescr(victim);
           label=PrintfHelpers.toSafe(_)+" killed "+PrintfHelpers.toSafe(_1);
           map.addLayer(new L.Marker([Number(lat),Number(longi)],{
            title:label,
            icon:skullIcon
           }));
          }
        }
       return;
      }
      finally
      {
       if(enumerator.Dispose!=undefined)
        {
         enumerator.Dispose();
        }
      }
     }),AttrProxy.Create("style","height: 600px")]),Runtime.New(T,{
      $:0
     })),Doc.Element("table",ats,List.ofArray([Doc.Element("thead",[],arg201),Doc.Element("tbody",[],arg205)]))]);
     return Doc.Element("div",[],arg20);
    },
    Schedule:function(instances)
    {
     var vInstance,vTime,vMission,vReason,vBroadcast,vStatus,vList,vChoice,attrs,submit,attrs1,getServerTime,attrs2,getList,x,_arg00_,taskView,x1,arg001,statusView,arg002,instances1,arg20a,arg20b,ats1,ats2,ats3,ats4,ats5,ats6,ats7;
     vInstance=Var.Create(Arrays.get(instances,0));
     vTime=Var.Create("");
     vMission=Var.Create("");
     vReason=Var.Create("");
     vBroadcast=Var.Create("");
     vStatus=Var.Create("");
     vList=Var.Create(Runtime.New(T,{
      $:0
     }));
     vChoice=Var.Create({
      $:0
     });
     attrs=List.ofArray([AttrProxy.Create("type","submit"),AttrProxy.Create("class","btn btn-primary")]);
     submit=Doc.Button("Add",attrs,function()
     {
      var arg00;
      arg00=Concurrency.Delay(function()
      {
       var time,instance,matchValue,_,message,message1,mission;
       time=Var.Get(vTime);
       instance=Var.Get(vInstance);
       matchValue=Var.Get(vChoice);
       if(matchValue.$==2)
        {
         message=Var.Get(vBroadcast);
         _=Concurrency.Bind(AjaxRemotingProvider.Async("SturmovikServerControl:4",[instance,time,message]),function(_arg2)
         {
          Var1.Set(vStatus,_arg2?"":"Failed to schedule broadcast");
          return Concurrency.Return(null);
         });
        }
       else
        {
         if(matchValue.$==1)
          {
           message1=Var.Get(vReason);
           _=Concurrency.Bind(AjaxRemotingProvider.Async("SturmovikServerControl:5",[instance,time,message1]),function(_arg3)
           {
            Var1.Set(vStatus,_arg3?"":"Failed to schedule shutdown");
            return Concurrency.Return(null);
           });
          }
         else
          {
           if(matchValue.$==3)
            {
             _=Concurrency.Bind(AjaxRemotingProvider.Async("SturmovikServerControl:6",[instance,time]),function(_arg4)
             {
              Var1.Set(vStatus,_arg4?"":"Failed to schedule campaign state reset");
              return Concurrency.Return(null);
             });
            }
           else
            {
             if(matchValue.$==4)
              {
               _=Concurrency.Bind(AjaxRemotingProvider.Async("SturmovikServerControl:7",[instance,time]),function(_arg5)
               {
                Var1.Set(vStatus,_arg5?"":"Failed to schedule campaign engine start");
                return Concurrency.Return(null);
               });
              }
             else
              {
               mission=Var.Get(vMission);
               _=Concurrency.Bind(AjaxRemotingProvider.Async("SturmovikServerControl:3",[instance,time,mission]),function(_arg1)
               {
                Var1.Set(vStatus,_arg1?"":"Failed to schedule mission");
                return Concurrency.Return(null);
               });
              }
            }
          }
        }
       return Concurrency.Combine(_,Concurrency.Delay(function()
       {
        return Concurrency.Bind(AjaxRemotingProvider.Async("SturmovikServerControl:9",[]),function(_arg6)
        {
         Var1.Set(vList,_arg6);
         return Concurrency.Return(null);
        });
       }));
      });
      return Concurrency.Start(arg00,{
       $:0
      });
     });
     attrs1=List.ofArray([AttrProxy.Create("class","btn btn-secondary")]);
     getServerTime=Doc.Button("Get server time",attrs1,function()
     {
      var arg00;
      arg00=Concurrency.Delay(function()
      {
       return Concurrency.Bind(AjaxRemotingProvider.Async("SturmovikServerControl:8",[]),function(_arg7)
       {
        Var1.Set(vTime,_arg7);
        return Concurrency.Return(null);
       });
      });
      return Concurrency.Start(arg00,{
       $:0
      });
     });
     attrs2=List.ofArray([AttrProxy.Create("class","btn btn-secondary")]);
     getList=Doc.Button("Refresh",attrs2,function()
     {
      var arg00;
      arg00=Concurrency.Delay(function()
      {
       return Concurrency.Bind(AjaxRemotingProvider.Async("SturmovikServerControl:9",[]),function(_arg8)
       {
        Var1.Set(vList,_arg8);
        return Concurrency.Return(null);
       });
      });
      return Concurrency.Start(arg00,{
       $:0
      });
     });
     x=vList.get_View();
     _arg00_=function(tasks)
     {
      var ats,arg20,arg201,arg202,arg203,arg204,arg205;
      ats=List.ofArray([AttrProxy.Create("class","table")]);
      arg202=List.ofArray([Doc.TextNode("Time")]);
      arg203=List.ofArray([Doc.TextNode("Event")]);
      arg204=Runtime.New(T,{
       $:0
      });
      arg201=List.ofArray([Doc.Element("th",[],arg202),Doc.Element("th",[],arg203),Doc.Element("th",[],arg204)]);
      arg20=List.ofArray([Doc.Element("tr",[],arg201)]);
      arg205=Seq.toList(Seq.delay(function()
      {
       return Seq.collect(function(matchValue)
       {
        var time,mission,instance,idx,attrs3,cancel,arg206,arg207,arg208,arg209;
        time=matchValue[1];
        mission=matchValue[2];
        instance=matchValue[0][0];
        idx=matchValue[0][1];
        attrs3=Runtime.New(T,{
         $:0
        });
        cancel=Doc.Button("X",attrs3,function()
        {
         var arg00;
         arg00=Concurrency.Delay(function()
         {
          return Concurrency.Bind(AjaxRemotingProvider.Async("SturmovikServerControl:10",[instance,idx]),function()
          {
           return Concurrency.Bind(Concurrency.Sleep(1000),function()
           {
            return Concurrency.Bind(AjaxRemotingProvider.Async("SturmovikServerControl:9",[]),function(_arg11)
            {
             Var1.Set(vList,_arg11);
             return Concurrency.Return(null);
            });
           });
          });
         });
         return Concurrency.Start(arg00,{
          $:0
         });
        });
        arg207=List.ofArray([Doc.TextNode(time)]);
        arg208=List.ofArray([Doc.TextNode(mission)]);
        arg209=List.ofArray([cancel]);
        arg206=List.ofArray([Doc.Element("td",[],arg207),Doc.Element("td",[],arg208),Doc.Element("td",[],arg209)]);
        return[Doc.Element("tr",[],arg206)];
       },tasks);
      }));
      return Doc.Element("table",ats,List.ofArray([Doc.Element("thead",[],arg20),Doc.Element("tbody",[],arg205)]));
     };
     taskView=Doc.BindView(_arg00_,x);
     x1=vStatus.get_View();
     arg001=function(msg)
     {
      return msg===""?Doc.get_Empty():Doc.Element("div",List.ofArray([AttrProxy.Create("class","alert alert-danger"),AttrProxy.Create("role","alert")]),List.ofArray([Doc.TextNode(msg)]));
     };
     statusView=View.Map(arg001,x1);
     arg002=Concurrency.Delay(function()
     {
      return Concurrency.Bind(AjaxRemotingProvider.Async("SturmovikServerControl:9",[]),function(_arg12)
      {
       Var1.Set(vList,_arg12);
       return Concurrency.Return(null);
      });
     });
     Concurrency.Start(arg002,{
      $:0
     });
     instances1=List.ofArray(instances);
     ats1=List.ofArray([AttrProxy.Create("class","form-group row")]);
     ats2=List.ofArray([AttrProxy.Create("class","form-group row")]);
     ats3=List.ofArray([AttrProxy.Create("class","form-group row")]);
     ats4=List.ofArray([AttrProxy.Create("class","form-group row")]);
     ats5=List.ofArray([AttrProxy.Create("class","form-group row")]);
     ats6=List.ofArray([AttrProxy.Create("class","form-group row")]);
     ats7=List.ofArray([AttrProxy.Create("class","form-group row")]);
     arg20b=List.ofArray([Doc.Element("div",ats1,List.ofArray([Doc.Element("div",List.ofArray([AttrProxy.Create("class","col-sm-1")]),Runtime.New(T,{
      $:0
     })),Doc.Element("label",List.ofArray([AttrProxy.Create("for","idInstance"),AttrProxy.Create("class","col-sm-1 form-control-label")]),List.ofArray([Doc.TextNode("Instance")])),Doc.Element("div",List.ofArray([AttrProxy.Create("class","col-sm-8")]),List.ofArray([Doc.Select(List.ofArray([AttrProxy.Create("type","text"),AttrProxy.Create("class","form-control"),AttrProxy.Create("id","idInstance"),AttrProxy.Create("placeholder","[[[yyyy/]mm]/dd] hh:mm")]),function(x2)
     {
      return x2;
     },instances1,vInstance)])),Doc.Element("div",List.ofArray([AttrProxy.Create("class","col-sm-2")]),Runtime.New(T,{
      $:0
     }))])),Doc.Element("div",ats2,List.ofArray([Doc.Element("div",List.ofArray([AttrProxy.Create("class","col-sm-1")]),Runtime.New(T,{
      $:0
     })),Doc.Element("label",List.ofArray([AttrProxy.Create("for","idTime"),AttrProxy.Create("class","col-sm-1 form-control-label")]),List.ofArray([Doc.TextNode("Time")])),Doc.Element("div",List.ofArray([AttrProxy.Create("class","col-sm-8")]),List.ofArray([Doc.Input(List.ofArray([AttrProxy.Create("type","text"),AttrProxy.Create("class","form-control"),AttrProxy.Create("id","idTime"),AttrProxy.Create("placeholder","[[[yyyy/]mm]/dd] hh:mm")]),vTime)])),Doc.Element("div",List.ofArray([AttrProxy.Create("class","col-sm-2")]),List.ofArray([getServerTime]))])),Doc.Element("div",ats3,List.ofArray([Doc.Radio(List.ofArray([AttrProxy.Create("class","col-sm-1")]),{
      $:0
     },vChoice),Doc.Element("label",List.ofArray([AttrProxy.Create("for","idMission"),AttrProxy.Create("class","col-sm-1 form-control-label")]),List.ofArray([Doc.TextNode("Mission")])),Doc.Element("div",List.ofArray([AttrProxy.Create("class","col-sm-8")]),List.ofArray([Doc.Input(List.ofArray([AttrProxy.Create("type","text"),AttrProxy.Create("class","form-control"),AttrProxy.Create("id","idMission"),AttrProxy.Create("placeholder","sds\\mission.sds")]),vMission)])),Doc.Element("div",List.ofArray([AttrProxy.Create("class","col-sm-2")]),Runtime.New(T,{
      $:0
     }))])),Doc.Element("div",ats4,List.ofArray([Doc.Radio(List.ofArray([AttrProxy.Create("class","col-sm-1")]),{
      $:1
     },vChoice),Doc.Element("label",List.ofArray([AttrProxy.Create("for","idReason"),AttrProxy.Create("class","col-sm-1 form-control-label")]),List.ofArray([Doc.TextNode("Shutdown")])),Doc.Element("div",List.ofArray([AttrProxy.Create("class","col-sm-8")]),List.ofArray([Doc.Input(List.ofArray([AttrProxy.Create("type","text"),AttrProxy.Create("class","form-control"),AttrProxy.Create("id","idReason"),AttrProxy.Create("placeholder","Message")]),vReason)])),Doc.Element("div",List.ofArray([AttrProxy.Create("class","col-sm-2")]),Runtime.New(T,{
      $:0
     }))])),Doc.Element("div",ats5,List.ofArray([Doc.Radio(List.ofArray([AttrProxy.Create("class","col-sm-1")]),{
      $:2
     },vChoice),Doc.Element("label",List.ofArray([AttrProxy.Create("for","idBroadcast"),AttrProxy.Create("class","col-sm-1 form-control-label")]),List.ofArray([Doc.TextNode("Broadcast")])),Doc.Element("div",List.ofArray([AttrProxy.Create("class","col-sm-8")]),List.ofArray([Doc.Input(List.ofArray([AttrProxy.Create("type","text"),AttrProxy.Create("class","form-control"),AttrProxy.Create("id","idBroadcast"),AttrProxy.Create("placeholder","Message")]),vBroadcast)])),Doc.Element("div",List.ofArray([AttrProxy.Create("class","col-sm-2")]),Runtime.New(T,{
      $:0
     }))])),Doc.Element("div",ats6,List.ofArray([Doc.Radio(List.ofArray([AttrProxy.Create("class","col-sm-1")]),{
      $:4
     },vChoice),Doc.Element("label",List.ofArray([AttrProxy.Create("for","idCampaign"),AttrProxy.Create("class","col-sm-1 form-control-label")]),List.ofArray([Doc.TextNode("Campaign")])),Doc.Element("div",List.ofArray([AttrProxy.Create("class","col-sm-8")]),Runtime.New(T,{
      $:0
     })),Doc.Element("div",List.ofArray([AttrProxy.Create("class","col-sm-2")]),Runtime.New(T,{
      $:0
     }))])),Doc.Element("div",ats7,List.ofArray([Doc.Radio(List.ofArray([AttrProxy.Create("class","col-sm-1")]),{
      $:3
     },vChoice),Doc.Element("label",List.ofArray([AttrProxy.Create("for","idCampaignReset"),AttrProxy.Create("class","col-sm-1 form-control-label")]),List.ofArray([Doc.TextNode("Campaign reset")])),Doc.Element("div",List.ofArray([AttrProxy.Create("class","col-sm-8")]),Runtime.New(T,{
      $:0
     })),Doc.Element("div",List.ofArray([AttrProxy.Create("class","col-sm-2")]),Runtime.New(T,{
      $:0
     }))])),Doc.Element("div",List.ofArray([AttrProxy.Create("class","form-group row")]),List.ofArray([Doc.Element("div",List.ofArray([AttrProxy.Create("class","col-sm-offset-1 col-sm-11")]),List.ofArray([submit]))]))]);
     arg20a=List.ofArray([Doc.Element("form",[],arg20b),Doc.EmbedView(statusView),taskView,getList]);
     return Doc.Element("div",[],arg20a);
    },
    Status:function(instances)
    {
     var arg20;
     arg20=Seq.toList(Seq.delay(function()
     {
      return Seq.map(function(instance)
      {
       return Client.StatusOfInstance(instance);
      },instances);
     }));
     return Doc.Element("div",[],arg20);
    },
    StatusOfInstance:function(instance)
    {
     var vStatus,vSps,vPlayers,update,action,arg10,offLoad,arg001,x1,arg002,playersView,arg206,arg207,arg208,arg209;
     vStatus=Var.Create("??");
     vSps=Var.Create("??");
     vPlayers=Var.Create(Runtime.New(T,{
      $:0
     }));
     update=Concurrency.Delay(function()
     {
      var x;
      x=AjaxRemotingProvider.Async("SturmovikServerControl:1",[instance]);
      return Concurrency.Bind(x,function(_arg1)
      {
       Var1.Set(vSps,Strings.PadLeft(_arg1.toFixed(1),3));
       return Concurrency.Bind(AjaxRemotingProvider.Async("SturmovikServerControl:0",[instance]),function(_arg2)
       {
        Var1.Set(vStatus,_arg2);
        return Concurrency.Bind(AjaxRemotingProvider.Async("SturmovikServerControl:2",[instance]),function(_arg3)
        {
         Var1.Set(vPlayers,_arg3);
         return Concurrency.Return(null);
        });
       });
      });
     });
     action=function()
     {
      var arg00;
      arg00=AjaxRemotingProvider.Async("SturmovikServerControl:12",[instance]);
      return Concurrency.Start(arg00,{
       $:0
      });
     };
     arg10=List.ofArray([AttrProxy.Create("class","btn btn-secondary")]);
     offLoad=Doc.Button("Reduce load",arg10,action);
     arg001=Concurrency.Delay(function()
     {
      return Concurrency.While(function()
      {
       return true;
      },Concurrency.Delay(function()
      {
       return Concurrency.Bind(update,function()
       {
        return Concurrency.Bind(Concurrency.Sleep(60000),function()
        {
         return Concurrency.Return(null);
        });
       });
      }));
     });
     Concurrency.Start(arg001,{
      $:0
     });
     x1=vPlayers.get_View();
     arg002=function(players)
     {
      var ats,arg20,arg201,arg202,arg203;
      ats=List.ofArray([AttrProxy.Create("class","table")]);
      arg202=List.ofArray([Doc.TextNode("Player name")]);
      arg201=List.ofArray([Doc.Element("th",[],arg202)]);
      arg20=List.ofArray([Doc.Element("tr",[],arg201)]);
      arg203=Seq.toList(Seq.delay(function()
      {
       return Seq.map(function(playerName)
       {
        var arg204,arg205;
        arg205=List.ofArray([Doc.TextNode(playerName)]);
        arg204=List.ofArray([Doc.Element("td",[],arg205)]);
        return Doc.Element("tr",[],arg204);
       },players);
      }));
      return Doc.Element("table",ats,List.ofArray([Doc.Element("thead",[],arg20),Doc.Element("tbody",[],arg203)]));
     };
     playersView=View.Map(arg002,x1);
     arg207=List.ofArray([Doc.TextNode("DServer instance: "+PrintfHelpers.toSafe(instance))]);
     arg208=List.ofArray([Doc.TextNode("Status: "),Doc.TextView(vStatus.get_View())]);
     arg209=List.ofArray([Doc.TextNode("Simulations per second: "),Doc.TextView(vSps.get_View())]);
     arg206=List.ofArray([Doc.Element("p",[],arg207),Doc.Element("p",[],arg208),Doc.Element("p",[],arg209),offLoad,Doc.EmbedView(playersView)]);
     return Doc.Element("div",[],arg206);
    }
   },
   Entry:{
    WarpStartFailureException:Runtime.Class({})
   }
  }
 });
 Runtime.OnInit(function()
 {
  UI=Runtime.Safe(Global.WebSharper.UI);
  Next=Runtime.Safe(UI.Next);
  Var=Runtime.Safe(Next.Var);
  List=Runtime.Safe(Global.WebSharper.List);
  AttrProxy=Runtime.Safe(Next.AttrProxy);
  Doc=Runtime.Safe(Next.Doc);
  Concurrency=Runtime.Safe(Global.WebSharper.Concurrency);
  Remoting=Runtime.Safe(Global.WebSharper.Remoting);
  AjaxRemotingProvider=Runtime.Safe(Remoting.AjaxRemotingProvider);
  Var1=Runtime.Safe(Next.Var1);
  View=Runtime.Safe(Next.View);
  Operators=Runtime.Safe(Global.WebSharper.Operators);
  Collections=Runtime.Safe(Global.WebSharper.Collections);
  FSharpMap=Runtime.Safe(Collections.FSharpMap);
  Seq=Runtime.Safe(Global.WebSharper.Seq);
  MapModule=Runtime.Safe(Collections.MapModule);
  PrintfHelpers=Runtime.Safe(Global.WebSharper.PrintfHelpers);
  AttrModule=Runtime.Safe(Next.AttrModule);
  L=Runtime.Safe(Global.L);
  GameLog=Runtime.Safe(Global.GameLog);
  JS=Runtime.Safe(GameLog.JS);
  Number=Runtime.Safe(Global.Number);
  Enumerator=Runtime.Safe(Global.WebSharper.Enumerator);
  T=Runtime.Safe(List.T);
  Math=Runtime.Safe(Global.Math);
  Arrays=Runtime.Safe(Global.WebSharper.Arrays);
  SturmovikServerControl=Runtime.Safe(Global.SturmovikServerControl);
  Client=Runtime.Safe(SturmovikServerControl.Client);
  return Strings=Runtime.Safe(Global.WebSharper.Strings);
 });
 Runtime.OnLoad(function()
 {
  return;
 });
}());
